%global momorel 15
Summary: Various compilers (C, C++, Objective-C, Java, ...)
Name: gcc

%global momonga_release 2.0
%global DATE 20050210
%global gcc_version 3.4.3
%global gcc_release %{momorel}m
#%%global _unpackaged_files_terminate_build 0
%global multilib_64_archs sparc64 ppc64 s390x x86_64
%ifarch s390x
%global multilib_32_arch s390
%endif
%ifarch sparc64
%global multilib_32_arch sparc
%endif
%ifarch ppc64
%global multilib_32_arch ppc
%endif
%ifarch x86_64
%global multilib_32_arch i686
%endif

# building D language support on x86_64, ppc were failed....
%global d_lang_arch %{ix86} 

Version: %{gcc_version}
Release: %{gcc_release}
License: GPL
Group: Development/Languages
URL: http://gcc.gnu.org/

############### Defines section

### include local configuration
%{?include_specopt}

### default configurations
#  If you'd like to change these configurations, please copy them to
# ~/rpm/specopt/gcc.specopt and edit it.

%{?!do_test:         %global do_test                 1}

## Configuration
# apply stack-smashing protection patch
# disable ssp patch for ppc
%ifarch ppc
  %global with_ssp 0
%else
  %{?!with_ssp:%global with_ssp 1}
%endif
# for bootstrap build(remove -fstack-protector from %%{optflags})
%{?!bootstrap_build:%global bootstrap_build 0}

#%%if !%{with_ssp}
#%%global bootstrap_build 1
#%%endif # !with_ssp

%ifarch %{d_lang_arch}

%if %{bootstrap_build}
%global build_d_lang 0
%else
%global build_d_lang 1
%endif

%else # !%{d_lang_arch}
%global build_d_lang 0
%endif


#Source0: ftp://ftp.gnu.org/gnu/gcc/gcc-%{version}/gcc-%{version}.tar.bz2
#NoSource: 0
%global srcname %{version}-%{DATE}
Source0: gcc-%{srcname}.tar.bz2
Source1: libgcc_post_upgrade.c

#Source1: http://www.research.ibm.com/trl/projects/security/ssp/gcc3_4_1/protector-3.4.1-1.tar.gz
#http://www.research.ibm.com/trl/projects/security/ssp/
#NoSource: 1
#Patch0: protector-3.4.3.diff
Patch0: protector-3.4.3-20050114.diff
Source2: libgcc_post_upgrade.c

%NoSource 10 http://home.earthlink.net/~dvdfrdmn/d/gdc-0.10.tar.bz2 ece1b586d23770d9999b95f8026e2ba9

BuildRoot: %{_tmppath}/%{name}-%{version}-root
# Need binutils with -pie support >= 2.14.90.0.4-4
# Need binutils which can omit dot symbols and overlap .opd on ppc64
BuildPreReq: binutils >= 2.14.90.0.4
#BuildPreReq: binutils >= 2.15.91.0.2-2m
BuildPreReq: zlib-devel >= 1.2.2-2m
BuildPreReq: gettext, bison, flex, texinfo
# Make sure pthread.h doesn't contain __thread tokens
BuildRequires: glibc-devel >= 2.2.90-12

Requires: cpp = %{version}-%{release}
# Need .eh_frame ld optimizations
# Need proper visibility support
# Need -pie support
# Need --as-needed/--no-as-needed support
# On ppc64, need omit dot symbols support and --non-overlapping-opd
%ifarch ppc ppc64
Requires: binutils >= 2.14.90.0.7
#Requires: binutils >= 2.15.91.0.2-2m
%else
Requires: binutils >= 2.14.90.0.4
#Requires: binutils >= 2.15.90.0.1.1-2
%endif
# Make sure gdb will understand DW_FORM_strp
Conflicts: gdb < 5.1-2
Requires: glibc-devel >= 2.2.90-12
Requires: libgcc >= %{version}-%{release}
Obsoletes: gcc3
Obsoletes: gcc-chill
Obsoletes: egcs
%ifarch sparc sparc64
Obsoletes: egcs64
%endif # sparc && sparc64
Prereq: info
AutoReq: true

# patches from Fedora
Patch1: gcc34-multi32-hack.patch
Patch2: gcc34-ice-hack.patch
Patch3: gcc34-ppc64-m32-m64-multilib-only.patch
Patch4: gcc34-ia64-lib64.patch
Patch5: gcc34-java-nomulti.patch
Patch6: gcc34-gnuc-rh-release.patch
Patch7: gcc34-pr16104.patch
Patch8: gcc34-ifcvt-pr19579.patch
Patch9: gcc34-demangle-pr16240.patch
Patch10: gcc34-noteGNUstack.patch
Patch11: gcc34-libgnat-nodlopen.patch
Patch12: gcc34-c++-pr18838.patch
Patch13: gcc34-c++-pr19666.patch
Patch14: gcc34-pie.patch

# for D language
Patch100: gcc-3.4.3-gdc-0.10.patch

%global _gnu %{nil}
%ifarch sparc
%global gcc_target_platform sparc64-%{_vendor}-%{_target_os}
%endif
%ifarch ppc
#%%global gcc_target_platform ppc64-%{_vendor}-%{_target_os}
%global gcc_target_platform ppc-%{_vendor}-%{_target_os}
%endif
%ifnarch sparc ppc
%global gcc_target_platform %{_target_platform}
%endif

%description
The gcc package contains the GNU Compiler Collection version 3.4.
You'll need this package in order to compile C code.

%package -n libgcc
Summary: GCC version 3.4 shared support library
Group: System Environment/Libraries
Provides: %{_prefix}/sbin/libgcc_post_upgrade
Autoreq: false

%description -n libgcc
This package contains GCC shared support library which is needed
e.g. for exception handling support.

%package c++
Summary: C++ support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libstdc++ = %{version}
Requires: libstdc++-devel = %{version}
Obsoletes: gcc3-c++
Autoreq: true

%description c++
This package adds C++ support to the GNU Compiler Collection.
It includes support for most of the current C++ specification,
including templates and exception handling.

%package -n libstdc++
Summary: GNU Standard C++ Library
Group: System Environment/Libraries
Obsoletes: libstdc++3
Autoreq: true

%description -n libstdc++
The libstdc++ package contains a rewritten standard compliant GCC Standard
C++ Library.

%package -n libstdc++-devel
Summary: Header files and libraries for C++ development
Group: Development/Libraries
Requires: libstdc++ = %{version}-%{release}
Obsoletes: libstdc++3-devel
Autoreq: true

%description -n libstdc++-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++
development. This includes rewritten implementation of STL.

%package objc
Summary: Objective-C support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libobjc = %{version}-%{release}
Obsoletes: gcc3-objc
Autoreq: true

%description objc
gcc-objc provides Objective-C support for the GCC.
Mainly used on systems running NeXTSTEP, Objective-C is an
object-oriented derivative of the C language.

%package -n libobjc
Summary: Objective-C runtime
Group: System Environment/Libraries
Autoreq: true

%description -n libobjc
This package contains Objective-C shared library which is needed to run
Objective-C dynamically linked programs.

%if !%{bootstrap_build}
%package g77
Summary: Fortran 77 support
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libf2c = %{version}-%{release}
Prereq: info
Obsoletes: gcc3-g77
Autoreq: true

%description g77
The gcc-g77 package provides support for compiling Fortran 77
programs with the GNU Compiler Collection.

%package -n libf2c
Summary: Fortran 77 runtime
Group: System Environment/Libraries
Autoreq: true

%description -n libf2c
This package contains Fortran 77 shared library which is needed to run
Fortran 77 dynamically linked programs.

%package java
Summary: Java support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libgcj >= %{version}, libgcj-devel >= %{version}, zlib-devel
Obsoletes: gcc3-java
Prereq: info
Autoreq: true

%description java
This package adds support for compiling Java(tm) programs and
bytecode into native code.

%package -n libgcj
Summary: Java runtime library for gcc
Group: System Environment/Libraries
Prereq: info, chkconfig
Requires: java-common, zip >= 2.1
Requires: gtk+ >= 2.4.0
BuildRequires: gtk+-devel >= 2.4.0
BuildRequires: libart_lgpl-devel >= 2.3.16
BuildRequires: expat-devel >= 1.95.6
Obsoletes: gcc-libgcj
Obsoletes: libgcj3
# Kaffe includes jar too
#Conflicts: kaffe
Autoreq: true

%description -n libgcj
The Java(tm) runtime library. You will need this package to run your Java
programs compiled using the Java compiler from GNU Compiler Collection (gcj).

%package -n libgcj-devel
Summary: Libraries for Java development using GCC
Group: Development/Languages
Requires: zip >= 2.1, libgcj = %{version}
Obsoletes: libgcj3-devel
Autoreq: true

%description -n libgcj-devel
The Java(tm) static libraries and C header files. You will need this
package to compile your Java programs using the GCC Java compiler (gcj).
%endif # !bootstrap_build

%package d
Summary: D language support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Autoreq: true

%description d
This package adds D language support to the GNU Compiler Collection.

%ifarch sparc
%package sparc32
Summary: The C compiler optimized for generating SPARC 32bit code
Group: Development/Languages
Requires: gcc = %{version}-%{release}, %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcc.a
Autoreq: true

%description sparc32
This package contains the GNU C compiler which only supports generating
32bit SPARC code, but should be faster than the 32/64bit gcc package. You
should install this package if you want to trade disk space required for
this package for faster compilation of 32bit code.

%package c++-sparc32
Summary: The C++ compiler optimized for generating SPARC 32bit code
Group: Development/Languages
Requires: gcc-c++ = %{version}-%{release}, gcc-sparc32 = %{version}-%{release}
Requires: %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.so
Autoreq: true

%description c++-sparc32
This package contains the GNU C++ compiler which only supports generating
32bit SPARC code, but should be faster than the 32/64bit gcc package. You
should install this package if you want to trade disk space required for
this package for faster compilation of 32bit code.
%endif # sparc

%ifarch ppc
%package ppc32
Summary: The C compiler optimized for generating PowerPC 32bit code
Group: Development/Languages
Requires: gcc = %{version}-%{release}, %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc.a
Autoreq: true

%description ppc32
This package contains the GNU C compiler which only supports generating
32bit PowerPC code, but should be faster than the 32/64bit gcc package. You
should install this package if you want to trade disk space required for
this package for faster compilation of 32bit code.

%package c++-ppc32
Summary: The C++ compiler optimized for generating PowerPC 32bit code
Group: Development/Languages
Requires: gcc-c++ = %{version}-%{release}, gcc-ppc32 = %{version}-%{release}
Requires: %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.so
Autoreq: true

%description c++-ppc32
This package contains the GNU C++ compiler which only supports generating
32bit PowerPC code, but should be faster than the 32/64bit gcc package. You
should install this package if you want to trade disk space required for
this package for faster compilation of 32bit code.
%endif # ppc

%package -n cpp
Summary: The C Preprocessor.
Group: Development/Languages
Prereq: info
%ifarch ia64
Obsoletes: gnupro
%endif # ia64
Autoreq: true

%description -n cpp
Cpp is the GNU C-Compatible Compiler Preprocessor.
Cpp is a macro processor which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define macros, abbreviations for longer
constructs.

The C preprocessor provides four separate functionalities: the
inclusion of header files (files of declarations that can be
substituted into your program); macro expansion (you can define macros,
and the C preprocessor will replace the macros with their definitions
throughout the program); conditional compilation (using special
preprocessing directives, you can include or exclude parts of the
program according to various conditions); and line control (if you use
a program to combine or rearrange source files into an intermediate
file which is then compiled, you can use line control to inform the
compiler about where each source line originated).

You should install this package if you are a C programmer and you use
macros.

%prep
%setup -q -n %{name}-%{srcname}

%if %{with_ssp}
#%%{__tar} zxf %{SOURCE1}
#%%{__patch} -p0 -i ./gcc_3_4_1.dif
#rm -f ./gcc_3_4_1.dif
%patch0 -p1 -b .ssp
%endif # with_ssp

## for D langage
%if %{build_d_lang}
pushd gcc
%{__tar} zxf %SOURCE10
patch -p1 -i d/patch-gcc-`echo %{gcc_version} | cut -d. -f1-2`.x
rm -f d/patch-gcc-*
pushd d
%patch100 -p1
popd
popd
%endif

%ifarch sparc ppc
%patch1 -p0 -b .multi32-hack~
%endif
%patch2 -p0 -b .ice-hack~
%patch3 -p0 -b .ppc64-m32-m64-multilib-only~
%ifarch ia64
%if "%{_lib}" == "lib64"
%patch4 -p0 -b .ia64-lib64~
%endif
%endif
%patch5 -p0 -b .java-nomulti~
%patch6 -p0 -b .gnuc-rh-release~
%patch7 -p0 -b .pr16104~
%patch8 -p0 -b .ifcvt-pr19579~
%patch9 -p0 -b .demangle-pr16240~
%patch10 -p0 -b .noteGNUstack~
%patch11 -p0 -b .libgnat-nodlopen~
%patch12 -p0 -b .c++-pr18838~
%patch13 -p0 -b .c++-pr19666~
%patch14 -p0 -b .ppc-pie~

#perl -pi -e 's/3\.4\.3/3.4.2/' gcc/version.c
perl -pi -e 's/"%{gcc_version}"/"%{gcc_version} \(release\)"/' gcc/version.c
perl -pi -e 's/\((prerelease|experimental|release|Red Hat[^)]*)\)/\(\Momonga Linux %{momonga_release} %{version}-%{gcc_release}\)/' gcc/version.c
#perl -pi -e 's/\((prerelease|experimental|release|Red Hat[^)]*)\)/\(%{version}-%{gcc_release}\)/' gcc/ada/gnatvsn.ads
# perl -pi -e 's/#define GCCBUGURL.*$/#define GCCBUGURL "<URL:http:\/\/www.momonga-linux.org\/>"/' gcc/system.h
# The version string is now longer than 32 bytes and the line containing it
# doesn't fit into 80 columns
#perl -pi -e 's/:= 32/:= 64/;s/(Gnat_Version_String.*:=)/\1\n    /' gcc/ada/gnatvsn.ads

# Misdesign in libstdc++
cp -a libstdc++-v3/config/cpu/i{4,3}86/atomicity.h

# Hack to avoid building multilib libjava
perl -pi -e 's/^all: all-redirect/ifeq (\$(MULTISUBDIR),)\nall: all-redirect\nelse\nall:\n\techo Multilib libjava build disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^install: install-redirect/ifeq (\$(MULTISUBDIR),)\ninstall: install-redirect\nelse\ninstall:\n\techo Multilib libjava install disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^check: check-redirect/ifeq (\$(MULTISUBDIR),)\ncheck: check-redirect\nelse\ncheck:\n\techo Multilib libjava check disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^all: all-recursive/ifeq (\$(MULTISUBDIR),)\nall: all-recursive\nelse\nall:\n\techo Multilib libjava build disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^install: install-recursive/ifeq (\$(MULTISUBDIR),)\ninstall: install-recursive\nelse\ninstall:\n\techo Multilib libjava install disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^check: check-recursive/ifeq (\$(MULTISUBDIR),)\ncheck: check-recursive\nelse\ncheck:\n\techo Multilib libjava check disabled\nendif/' libjava/Makefile.in

./contrib/gcc_update --touch

%build

rm -fr obj-%{gcc_target_platform}
mkdir obj-%{gcc_target_platform}
cd obj-%{gcc_target_platform}

if [ ! -f /usr/lib/locale/de_DE/LC_CTYPE ]; then
  mkdir locale
  localedef -f ISO-8859-1 -i de_DE locale/de_DE
  export LOCPATH=`pwd`/locale:/usr/lib/locale
fi

CC=gcc
OPT_FLAGS=`echo %{optflags}|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-m64//g;s/-m32//g;s/-m31//g'`
%if %{bootstrap_build}
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-fstack-protector//g'`
%endif # bootstrap_build
%ifarch ppc
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-m64//g;s/-m31//g'`
%endif #ppc
%ifarch sparc sparc64
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-mcpu=ultrasparc/-mtune=ultrasparc/g'`
%endif # sparc && sparc64
%ifarch sparc64
cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
chmod +x gcc64
CC=`pwd`/gcc64
%endif # sparc64
%ifarch ppc64
if gcc -m64 -xc -S /dev/null -o - > /dev/null 2>&1; then
  cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
  chmod +x gcc64
  CC=`pwd`/gcc64
fi
%endif # ppc64

%if %{build_d_lang} 
BUILD_LANGS='c,d,c++,f77,java,objc'
%else
BUILD_LANGS='c,c++,f77,java,objc'
%endif

CC="$CC" CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" TCFLAGS="$OPT_FLAGS" \
	GCJFLAGS="$OPT_FLAGS" \
	../configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
	--enable-shared --enable-threads=posix --disable-checking \
	--with-system-zlib --enable-__cxa_atexit --disable-libunwind-exceptions \
%if %{bootstrap_build}
	--enable-languages='c,c++' \
	--disable-libgcj --disable-libjava --disable-libobjc \
%else # !bootstrap_build
	--enable-languages=$BUILD_LANGS \
	--enable-java-gc=boehm --enable-java-awt=gtk \
%endif # !bootstrap_build
%ifarch sparc
	--host=%{gcc_target_platform} --build=%{gcc_target_platform} --target=%{gcc_target_platform} --with-cpu=v7
%endif # sparc
%ifarch ppc
	--host=%{gcc_target_platform} --build=%{gcc_target_platform} --target=%{gcc_target_platform} --with-cpu=default32
%endif # ppc
%ifnarch sparc ppc
	--host=%{gcc_target_platform}
%endif # !sparc ppc

%if !%{with_ssp}
# if RPM_BUILD_NCPUS unset, set it
if [ -z "$RPM_BUILD_NCPUS" ] ; then
  if [ -x /usr/bin/getconf ] ; then
    RPM_BUILD_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN)
    if [ $RPM_BUILD_NCPUS -eq 0 ]; then
      RPM_BUILD_NCPUS=1
    fi
  else
    RPM_BUILD_NCPUS=1
  fi
fi
%else # !with_ssp
RPM_BUILD_NCPUS=1
%endif # !with_ssp
#make -j$RPM_BUILD_NCPUS bootstrap
%ifarch %{ix86} x86_64
make -j$RPM_BUILD_NCPUS BOOT_CFLAGS="$OPT_FLAGS" profiledbootstrap
%else
make -j$RPM_BUILD_NCPUS BOOT_CFLAGS="$OPT_FLAGS" bootstrap-lean
%endif

%if %{do_test}
# run the tests.
make -j$RPM_BUILD_NCPUS -k check || :
make -C %{gcc_target_platform}/libstdc++-v3/testsuite -k check-abi-verbose || :
echo ====================TESTING=========================
( ../contrib/test_summary || : ) 2>&1 | sed -n '/^cat.*EOF/,/^EOF/{/^cat.*EOF/d;/^EOF/d;/^LAST_UPDATED:/d;p;}'
make -C %{gcc_target_platform}/libstdc++-v3/testsuite -k check-abi || :
echo ====================TESTING END=====================
#cd %{gcc_target_platform}/libstdc++-v3
#./mkcheck 0
#cd ../..
%endif # do_test

# Make protoize
make -C gcc CC="./xgcc -B ./ -O2" proto

%if %{bootstrap_build}
OPT_FLAGS=`echo "%{optflags}"|sed -e 's/-fstack-protector//g'`
%endif # bootstrap_build

%ifarch sparc ppc
# Build the -m32 only compiler which does not use long long for HOST_WIDE_INT
mkdir gcc32
cd gcc32
OPT_FLAGS=`echo "$OPT_FLAGS"|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
echo "#!/bin/sh" > gcc32
echo "exec `cd ../gcc; pwd`/xgcc -B `cd ../gcc; pwd`/ $OPT_FLAGS \$*" >> gcc32
chmod +x gcc32
CC=`pwd`/gcc32 CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" \
  TCFLAGS="$OPT_FLAGS" ../../configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
  --enable-shared --enable-threads=posix --disable-checking --disable-libunwind-exceptions \
  --with-system-zlib --enable-__cxa_atexit --enable-languages=c,c++ \
  --host=%{_target_platform} --build=%{_target_platform} --target=%{_target_platform}
make %{?_smp_mflags} BOOT_CFLAGS="$OPT_FLAGS" all-gcc
cd ..
%endif # sparc ppc

%if %{build_d_lang}
## build D language runtime
cp -a ../gcc/d/dmd-script gcc/dmd
chmod 0755 gcc/dmd
PATH_old="$PATH"
PATH="%{_builddir}/%{name}-%{srcname}/obj-%{gcc_target_platform}/gcc:$PATH"
mkdir "%{_target_platform}/phobos"
pushd "%{_target_platform}/phobos"
DFLAGS="-O2 -g -frelease" ../../../gcc/d/phobos/configure --prefix=%{_prefix} --enable-unix --enable-loader
make
popd 
PATH="$PATH_old"
rm -f gcc/dmd
%endif

# Make generated man pages even if Pod::Man is not new enough
perl -pi -e 's/head3/head2/' ../contrib/texi2pod.pl
for i in ../gcc/doc/*.texi; do
  cp -a $i $i.orig; sed 's/ftable/table/' $i.orig > $i
done
make -C gcc generated-manpages
for i in ../gcc/doc/*.texi; do mv -f $i.orig $i; done

# Copy various doc files here and there
cd ..
%if !%{bootstrap_build}
mkdir -p rpm.doc/g77
mkdir -p rpm.doc/objc
mkdir -p rpm.doc/boehm-gc
mkdir -p rpm.doc/fastjar rpm.doc/libffi rpm.doc/libjava
%endif # !bootstrap_build

(cd gcc/f; for i in ChangeLog*; do
	cp -p $i ../../rpm.doc/g77/$i.f
done)
%if !%{bootstrap_build}
(cd libf2c; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/g77/$i.libf2c
done)
(cd gcc/objc; for i in README*; do
	cp -p $i ../../rpm.doc/objc/$i.objc
done)
(cd libobjc; for i in README*; do
	cp -p $i ../rpm.doc/objc/$i.libobjc
done)
(cd boehm-gc; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/boehm-gc/$i.gc
done)
(cd fastjar; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/fastjar/$i.fastjar
done)
(cd libffi; for i in ChangeLog* README* LICENSE; do
	cp -p $i ../rpm.doc/libffi/$i.libffi
done)
(cd libjava; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/libjava/$i.libjava
done)
%endif # !bootstrap_build

%install
rm -fr %{buildroot}

perl -pi -e \
  's~href="l(ibstdc|atest)~href="http://gcc.gnu.org/onlinedocs/libstdc++/l\1~' \
  libstdc++-v3/docs/html/documentation.html
ln -sf documentation.html libstdc++-v3/docs/html/index.html
find libstdc++-v3/docs/html -name CVS | xargs rm -rf

cd obj-%{gcc_target_platform}

if [ ! -f /usr/lib/locale/de_DE/LC_CTYPE ]; then
  export LOCPATH=`pwd`/locale:/usr/lib/locale
fi

TARGET_PLATFORM=%{gcc_target_platform}

# There are some MP bugs in libstdc++ and libjava Makefiles
make -C %{gcc_target_platform}/libstdc++-v3
%if !%{bootstrap_build}
make -C %{gcc_target_platform}/libjava
%endif # !bootstrap_build

make prefix=%{buildroot}%{_prefix} mandir=%{buildroot}%{_mandir} \
  infodir=%{buildroot}%{_infodir} install

# multilib gcc use %{_prefix}/lib/gcc (not %{_libdir}/gcc)
FULLPATH=%{buildroot}%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}

FULLEPATH=%{buildroot}%{_libexecdir}/gcc/%{gcc_target_platform}/%{gcc_version}

# fix some things
ln -sf gcc %{buildroot}%{_prefix}/bin/cc
mkdir -p %{buildroot}/lib
ln -sf ..%{_prefix}/bin/cpp %{buildroot}/lib/cpp
%if !%{bootstrap_build}
ln -sf g77 %{buildroot}%{_prefix}/bin/f77
%endif # !bootstrap_build
rm -f %{buildroot}%{_infodir}/dir
#gzip -9 %{buildroot}%{_infodir}/*.info*
#ln -sf gcc %{buildroot}%{_prefix}/bin/gnatgcc

cxxconfig="`find %{gcc_target_platform}/libstdc++-v3/include -name c++config.h`"

for i in `find %{gcc_target_platform}/[36]*/libstdc++-v3/include -name c++config.h 2>/dev/null`; do
  if ! diff -up $cxxconfig $i; then
    cat > %{buildroot}%{_prefix}/include/c++/%{gcc_version}/%{gcc_target_platform}/bits/c++config.h <<EOF
#ifndef _CPP_CPPCONFIG_WRAPPER
#define _CPP_CPPCONFIG_WRAPPER 1
#include <bits/wordsize.h>
#if __WORDSIZE == 32
%ifarch %{multilib_64_archs}
`cat $(find %{gcc_target_platform}/32/libstdc++-v3/include -name c++config.h)`
%else
`cat $(find %{gcc_target_platform}/libstdc++-v3/include -name c++config.h)`
%endif
#else
%ifarch %{multilib_64_archs}
`cat $(find %{gcc_target_platform}/libstdc++-v3/include -name c++config.h)`
%else
`cat $(find %{gcc_target_platform}/64/libstdc++-v3/include -name c++config.h)`
%endif
#endif
#endif
EOF
    break
  fi
done

%if !%{bootstrap_build}
for prog in jar rmic rmiregistry; do
%__mv -f %{buildroot}%{_bindir}/$prog %{buildroot}%{_bindir}/gcj-$prog
%__mv -f %{buildroot}%{_mandir}/man1/$prog.1 %{buildroot}%{_mandir}/man1/gcj-$prog.1
done
%endif # !bootstrap_build

%if %{build_d_lang}
## D language runtime
pushd %{gcc_target_platform}/phobos
%makeinstall
popd
%endif

%ifarch sparc ppc
# Install the sparc/ppc -m32 only compilers
FULLPATH32=%{buildroot}%{_prefix}/lib/gcc/%{_target_platform}/%{gcc_version}
FULLEPATH32=%{buildroot}%{_libexecdir}/gcc/%{_target_platform}/%{gcc_version}
mkdir -p $FULLPATH32 $FULLEPATH32
#ln -sf %{buildroot}%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include \
#  $FULLPATH32/
install -m 755 gcc32/gcc/cc1 $FULLEPATH32/
install -m 755 gcc32/gcc/cc1plus $FULLEPATH32/
#ln -f %{buildroot}%{_prefix}/bin/%{gcc_target_platform}-gcc \
#  %{buildroot}%{_prefix}/bin/%{_target_platform}-gcc
%endif # sparc ppc
%ifarch sparc
ln -sf %{gcc_target_platform} \
  %{buildroot}%{_prefix}/include/c++/%{gcc_version}/%{_target_platform}
%endif # sparc
%ifarch ppc
#mv %{buildroot}%{_prefix}/include/c++/%{gcc_version}/%{gcc_target_platform} \
#  %{buildroot}%{_prefix}/include/c++/%{gcc_version}/%{_target_platform}
ln -sf %{_target_platform} \
  %{buildroot}%{_prefix}/include/c++/%{gcc_version}/%{gcc_target_platform}
%endif # ppc
%ifarch sparc64
ln -f %{buildroot}%{_prefix}/bin/%{gcc_target_platform}-gcc \
  %{buildroot}%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-gcc
%endif # sparc64
%ifarch ppc64
ln -f %{buildroot}%{_prefix}/bin/%{gcc_target_platform}-gcc \
  %{buildroot}%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-gcc
%endif # ppc64

%ifarch sparc ppc
FULLLPATH=$FULLPATH/lib32
%endif # sparc ppc
%ifarch sparc64 ppc64
FULLLPATH=$FULLPATH/lib64
%endif # sparc64 ppc64
if [ -n "$FULLLPATH" ]; then
  mkdir -p $FULLLPATH
else
  FULLLPATH=$FULLPATH
fi

%if !%{bootstrap_build}
mv %{buildroot}%{_libdir}/libgcj.*a $FULLLPATH/
mv %{buildroot}%{_libdir}/lib-gnu-java-awt-peer-gtk.*a $FULLLPATH/
mv %{buildroot}%{_libdir}/lib-org-*.*a $FULLLPATH/
#sed 's/-lgcjgc//g;s/-lzgcj//g;s/-lpthread//g' %{buildroot}%{_prefix}/lib/libgcj.spec > $FULLPATH/libgcj.spec
mv %{buildroot}%{_prefix}/lib/libgcj.spec $FULLPATH/
#mv %{buildroot}%{_prefix}/include/gc*.h $FULLPATH/include/
mv %{buildroot}%{_prefix}/include/j*.h $FULLPATH/include/
#mv -f %{buildroot}%{_prefix}/include/{java,javax,gnu,org} $FULLPATH/include/
mv -f %{buildroot}%{_prefix}/include/{java,javax,gnu} $FULLPATH/include/
mkdir -p $FULLPATH/include/gcj
mv -f %{buildroot}%{_prefix}/include/gcj/* $FULLPATH/include/gcj/
rmdir %{buildroot}%{_prefix}/include/gcj
%endif # !bootstrap_build

mkdir -p %{buildroot}/%{_lib}
mv -f %{buildroot}%{_libdir}/libgcc_s.so.1 %{buildroot}/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
chmod 755 %{buildroot}/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
ln -sf libgcc_s-%{gcc_version}-%{DATE}.so.1 %{buildroot}/%{_lib}/libgcc_s.so.1
ln -sf /%{_lib}/libgcc_s.so.1 $FULLPATH/libgcc_s.so

%ifarch sparc ppc
ln -sf ../../../../../lib/libgcc_s.so.1 $FULLPATH/libgcc_s_32.so
#ln -sf /lib64/libgcc_s.so.1 $FULLPATH/libgcc_s_64.so
%endif # sparc ppc
%ifarch %{multilib_64_archs}
ln -sf /lib/libgcc_s.so.1 $FULLPATH/libgcc_s_32.so
%endif # multilib_64_archs

pushd $FULLPATH
if [ "%{_lib}" = "lib" ]; then
ln -sf ../../../libstdc++.so.6.* libstdc++.so
%if !%{bootstrap_build}
ln -sf ../../../libobjc.so.1 libobjc.so
ln -sf ../../../libgcj.so.5.* libgcj.so
ln -sf ../../../lib-gnu-java-awt-peer-gtk.so.5.* lib-gnu-java-awt-peer-gtk.so
ln -sf ../../../lib-org-w3c-dom.so.5.* lib-org-w3c-dom.so
ln -sf ../../../lib-org-xml-sax.so.5.* lib-org-xml-sax.so
ln -sf ../../../libg2c.so.0.* libg2c.so
%endif # !bootstrap_build
else
ln -sf ../../../../%{_lib}/libstdc++.so.6.* libstdc++.so
%if !%{bootstrap_build}
ln -sf ../../../../%{_lib}/libobjc.so.1 libobjc.so
ln -sf ../../../../%{_lib}/libgcj.so.5.* libgcj.so
ln -sf ../../../../%{_lib}/lib-gnu-java-awt-peer-gtk.so.5.* lib-gnu-java-awt-peer-gtk.so
ln -sf ../../../../%{_lib}/lib-org-w3c-dom.so.5.* lib-org-w3c-dom.so
ln -sf ../../../../%{_lib}/lib-org-xml-sax.so.5.* lib-org-xml-sax.so
ln -sf ../../../../%{_lib}/libg2c.so.0.* libg2c.so
%endif # !bootstrap_build
fi
mv -f %{buildroot}%{_libdir}/libstdc++.*a $FULLLPATH/
mv -f %{buildroot}%{_libdir}/libsupc++.*a .
%if !%{bootstrap_build}
mv -f %{buildroot}%{_libdir}/libfrtbegin.*a .
mv -f %{buildroot}%{_libdir}/libg2c.*a .
mv -f %{buildroot}%{_libdir}/libobjc.*a .
%endif # !bootstrap_build

%ifarch sparc ppc
mkdir -p 32
#ln -sf ../`echo ../../../../lib/libstdc++.so.6.* | sed s~/lib/~/lib64/~` 64/libstdc++.so
%if !%{bootstrap_build}
#ln -sf ../../../../../lib64/libobjc.so.1 64/libobjc.so
#ln -sf ../`echo ../../../../lib/libgcj.so.5.* | sed s~/lib/~/lib64/~` 64/libgcj.so
#ln -sf ../`echo ../../../../lib/lib-gnu-java-awt-peer-gtk.so.5.* | sed s~/lib/~/lib64/~` 64/lib-gnu-java-awt-peer-gtk.so
#ln -sf ../`echo ../../../../lib/lib-org-w3c-dom.so.5.* | sed s~/lib/~/lib64/~` 64/lib-org-w3c-dom.so
#ln -sf ../`echo ../../../../lib/lib-org-xml-sax.so.5.* | sed s~/lib/~/lib64/~` 64/lib-org-xml-sax.so
#ln -sf ../`echo ../../../../lib/libg2c.so.0.* | sed s~/lib/~/lib64/~` 64/libg2c.so
%endif # !bootstrap_build
#mv -f %{buildroot}%{_prefix}/lib32/libsupc++.*a 64/
#mv -f %{buildroot}%{_prefix}/lib/gcc/ppc-momonga-linux/3.4.3/libsupc++.*a 32/
ln -sf crt*.o 32/
ln -sf ../crtbegin.o 32/
ln -sf ../crtbeginS.o 32/
ln -sf ../crtbeginT.o 32/
ln -sf ../crtend.o 32/
ln -sf ../crtendS.o 32/
ln -sf ../crtsavres.o 32/
ln -sf ../libgcov.a 32/
ln -sf ../libgcc.a 32/
ln -sf ../libgcc_eh.a 32/
ln -sf ../libstdc++.so 32/
ln -sf ../libstdc++.a 32/
ln -sf ../libobjc.a 32/
ln -sf ../libobjc.so 32/
ln -sf ../libg2c.a 32/
ln -sf ../libg2c.so 32/
ln -sf ../libfrtbegin.a 32/
ln -sf ../libgcj.so 32/
ln -sf ../lib32/libgcj.a 32/
ln -sf ../lib-gnu-java-awt-peer-gtk.so 32/
ln -sf ../lib-gnu-java-awt-peer-gtk.a 32/
ln -sf ../../../../lib-org-w3c-dom.so 32/
ln -sf ../lib32/lib-org-w3c-dom.a 32/
ln -sf ../../../../lib-org-xml-sax.so 32/
ln -sf ../lib32/lib-org-xml-sax.a 32/
ln -sf lib32/libstdc++.a .


mkdir -p 64
%if !%{bootstrap_build}
#mv -f %{buildroot}%{_prefix}/lib64/libg2c.*a 64/
#mv -f %{buildroot}%{_prefix}/lib64/libfrtbegin.*a 64/
#mv -f %{buildroot}%{_prefix}/lib64/libobjc.*a 64/
%endif # !bootstrap_build
#ln -sf lib32/libstdc++.a libstdc++.a
#ln -sf ../lib64/libstdc++.a 32/libstdc++.a
%if !%{bootstrap_build}
ln -sf lib32/libgcj.a libgcj.a
#ln -sf ../lib64/libgcj.a 64/libgcj.a
#ln -sf ../lib64/lib-gnu-java-awt-peer-gtk.a 64/lib-gnu-java-awt-peer-gtk.a
ln -sf lib32/lib-gnu-java-awt-peer-gtk.a lib-gnu-java-awt-peer-gtk.a
ln -sf lib32/lib-org-w3c-dom.a lib-org-w3c-dom.a
#ln -sf ../lib64/lib-org-w3c-dom.a 64/lib-org-w3c-dom.a
ln -sf lib32/lib-org-xml-sax.a lib-org-xml-sax.a
#ln -sf ../lib64/lib-org-xml-sax.a 64/lib-org-xml-sax.a
%endif # !bootstrap_build
%endif # sparc ppc
%ifarch %{multilib_64_archs}
mkdir -p 32
ln -sf ../`echo ../../../../lib64/libstdc++.so.6.* | sed s~/../lib64/~/~` 32/libstdc++.so
%if !%{bootstrap_build}
ln -sf ../../../../libobjc.so.1 32/libobjc.so
ln -sf ../`echo ../../../../lib64/libgcj.so.5.* | sed s~/../lib64/~/~` 32/libgcj.so
ln -sf ../`echo ../../../../lib64/lib-gnu-java-awt-peer-gtk.so.5.* | sed s~/../lib64/~/~` 32/lib-gnu-java-awt-peer-gtk.so
ln -sf ../`echo ../../../../lib64/lib-org-w3c-dom.so.5.* | sed s~/../lib64/~/~` 32/lib-org-w3c-dom.so
ln -sf ../`echo ../../../../lib64/lib-org-xml-sax.so.5.* | sed s~/../lib64/~/~` 32/lib-org-xml-sax.so
ln -sf ../`echo ../../../../lib64/libg2c.so.0.* | sed s~/../lib64/~/~` 32/libg2c.so
%endif # !bootstrap_build
mv -f %{buildroot}%{_prefix}/lib/libsupc++.*a 32/
#mv -f %{buildroot}%{_libdir}/libsupc++.*a .
%if !%{bootstrap_build}
mv -f %{buildroot}%{_prefix}/lib/libg2c.*a 32/
mv -f %{buildroot}%{_prefix}/lib/libfrtbegin.*a 32/
mv -f %{buildroot}%{_prefix}/lib/libobjc.*a 32/
%endif # !bootstrap_build
%endif # multilib_64_archs
%ifarch sparc64 ppc64
ln -sf ../lib32/libstdc++.a 32/libstdc++.a
ln -sf lib64/libstdc++.a libstdc++.a
%if !%{bootstrap_build}
ln -sf ../lib32/libgcj.a 32/libgcj.a
ln -sf lib64/libgcj.a libgcj.a
ln -sf ../lib32/lib-gnu-java-awt-peer-gtk.a 32/lib-gnu-java-awt-peer-gtk.a
ln -sf lib64/lib-gnu-java-awt-peer-gtk.a lib-gnu-java-awt-peer-gtk.a
ln -sf ../lib32/lib-org-w3c-dom.a 32/lib-org-w3c-dom.a
ln -sf lib64/lib-org-w3c-dom.a lib-org-w3c-dom.a
ln -sf ../lib32/lib-org-xml-sax.a 32/lib-org-xml-sax.a
ln -sf lib64/lib-org-xml-sax.a lib-org-xml-sax.a
%endif # !bootstrap_build
%else
%ifarch %{multilib_64_archs}
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libstdc++.a 32/libstdc++.a
%if !%{bootstrap_build}
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libgcj.a 32/libgcj.a
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/lib-gnu-java-awt-peer-gtk.a 32/lib-gnu-java-awt-peer-gtk.a
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/lib-org-w3c-dom.a 32/lib-org-w3c-dom.a
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/lib-org-xml-sax.a 32/lib-org-xml-sax.a
%endif # !bootstrap_build
%endif # multilib_64_archs
%endif # sparc64 ppc64

%if !%{bootstrap_build}
# Strip debug info from Fortran/ObjC/Java static libraries
strip -g `find . \( -name libg2c.a -o -name libobjc.a -o -name libgcj.a \
                    -o -name lib-gnu-java-awt-peer-gtk.a \
                    -o -name lib-org-w3c-dom.a -o -name lib-org-xml-sax.a \
                    -o -name libgcc.a -o -name libgcov.a \) -a -type f`

chmod 755 %{buildroot}%{_libdir}/libg2c.so.0.*
chmod 755 %{buildroot}%{_libdir}/libobjc.so.1.*
%endif # !bootstrap_build
popd

for h in `find $FULLPATH/include -name \*.h`; do
  if grep -q 'It has been auto-edited by fixincludes from' $h; then
    rh=`grep -A2 'It has been auto-edited by fixincludes from' $h | tail -1 | sed 's|^.*"\(.*\)".*$|\1|'`
    diff -up $rh $h || :
    rm -f $h
  fi
done

# gcj -static doesn't work properly anyway, unless using --whole-archive
# and saving 35MB is not bad.
find $FULLPATH -name libgcj.a -o -name lib-\*.a | xargs rm -f
sed -i -e 's/lib: /&%%{static:%%eJava programs cannot be linked statically}/' \
  $FULLPATH/libgcj.spec

cat > %{buildroot}%{_prefix}/bin/c89 <<"EOF"
#!/bin/sh
fl="-std=c89"
for opt; do
  case "$opt" in
    -ansi|-std=c89|-std=iso9899:1990) fl="";;
    -std=*) echo "`basename $0` called with non ANSI/ISO C option $opt" >&2
           exit 1;;
  esac
done
exec %{_prefix}/bin/gcc $fl ${1+"$@"}
EOF

cat > %{buildroot}%{_prefix}/bin/c99 <<"EOF"
#!/bin/sh
fl="-std=c99"
for opt; do
  case "$opt" in
    -std=c99|-std=iso9899:1999) fl="";;
    -std=*) echo "`basename $0` called with non ISO C99 option $opt" >&2
           exit 1;;
  esac
done
exec %{_prefix}/bin/gcc $fl ${1+"$@"}
EOF

chmod 755 %{buildroot}%{_prefix}/bin/c?9

mkdir -p %{buildroot}%{_prefix}/sbin
gcc -static -Os %{SOURCE2} -o %{buildroot}%{_prefix}/sbin/libgcc_post_upgrade

#strip %{buildroot}%{_prefix}/sbin/libgcc_post_upgrade

cd ..
%find_lang %{name}

%ifarch %{ix86}
pushd %{buildroot}%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
mv specs specs~
## fix specs for ssp
sed -e 's/^%%{static|static-libgcc:-lgcc -lgcc_eh}/%%{static|static-libgcc:-lgcc -lgcc_eh %%{profile:-lc_p} %%{!profile: -lc}}/' < specs~ > specs
rm specs~
popd
%endif

# Ugly... orz
%ifarch %{multilib_64_archs}
mkdir -p %{buildroot}%{_libdir}/pkgconfig
sed -e 's|/lib|/lib64|' < %{buildroot}%{_prefix}/lib/pkgconfig/libgcj.pc > %{buildroot}%{_libdir}/pkgconfig/libgcj.pc
rm -f %{buildroot}%{_prefix}/lib/pkgconfig/libgcj.pc
%endif

# remove. Please modify %%files if needed.
rm -f %{buildroot}%{_bindir}/gccbug
rm -f %{buildroot}%{_bindir}/%{gcc_target_platform}-gcc-%{gcc_version}
rm -f %{buildroot}%{_bindir}/%{gcc_target_platform}-gcj*
rm -f %{buildroot}%{_includedir}/ffi.h
rm -f %{buildroot}%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/SYSCALLS.c.X
rm -rf %{buildroot}%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/libffi
rm -rf %{buildroot}%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/install-tools
rm -f %{buildroot}%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/*.la
rm -f %{buildroot}%{_libdir}/libffi*
rm -f %{buildroot}%{_prefix}/lib/libiberty.a
rm -rf %{buildroot}%{_libexecdir}/gcc/%{gcc_target_platform}/%{gcc_version}/install-tools
rm -f %{buildroot}%{_datadir}/locale/de/LC_MESSAGES/libstdc++.mo
rm -f %{buildroot}%{_datadir}/locale/fr/LC_MESSAGES/libstdc++.mo
rm -rf %{buildroot}%{_datadir}/man/man7
%ifarch %{multilib_64_archs}
rm -rf %{buildroot}%{_prefix}/lib/32
rm -f %{buildroot}%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/*.la
rm -f %{buildroot}%{_prefix}/lib/libffi*
rm -f %{buildroot}%{_prefix}/lib/libg2c.so.*
rm -f %{buildroot}%{_prefix}/lib/libgcc_s.so.*
rm -f %{buildroot}%{_prefix}/lib/libobjc.so.*
rm -f %{buildroot}%{_prefix}/lib/libstdc++.*
%endif

%clean
rm -rf %{buildroot}

%post
/sbin/install-info --info-dir=%{_infodir} %{_infodir}/gcc.info

%preun
if [ $1 = 0 ]; then
  /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/gcc.info
fi

%post -n cpp
/sbin/install-info --info-dir=%{_infodir} %{_infodir}/cpp.info

%preun -n cpp
if [ $1 = 0 ]; then
  /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/cpp.info
fi

# Because glibc Prereq's libgcc and /sbin/ldconfig
# comes from glibc, it might not exist yet when
# libgcc is installed
#%%post -n libgcc -p /sbin/ldconfig
%post -n libgcc -p %{_prefix}/sbin/libgcc_post_upgrade

%postun -n libgcc -p /sbin/ldconfig

%post -n libstdc++ -p /sbin/ldconfig

%postun -n libstdc++ -p /sbin/ldconfig

%if !%{bootstrap_build}
%post g77
/sbin/install-info --info-dir=%{_infodir} %{_infodir}/g77.info

%preun g77
if [ $1 = 0 ]; then
  /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/g77.info
fi

%post java
/sbin/install-info --info-dir=%{_infodir} %{_infodir}/gcj.info

%preun java
if [ $1 = 0 ]; then
  /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/gcj.info
fi

%post -n libobjc -p /sbin/ldconfig

%postun -n libobjc -p /sbin/ldconfig

%post -n libgcj
/sbin/ldconfig
/sbin/install-info --info-dir=%{_infodir} %{_infodir}/fastjar.info

%{_sbindir}/alternatives --install %{_bindir}/jar jar %{_bindir}/gcj-jar 40 \
	--slave %{_mandir}/man1/jar.1.bz2 jar.1.bz2 %{_mandir}/man1/gcj-jar.1.bz2
%{_sbindir}/alternatives --install %{_bindir}/rmic rmic %{_bindir}/gcj-rmic 40 \
	--slave %{_mandir}/man1/rmic.1.bz2 rmic.1.bz2 %{_mandir}/man1/gcj-rmic.1.bz2
%{_sbindir}/alternatives --install %{_bindir}/rmiregistry rmiregistry %{_bindir}/gcj-rmiregistry 40 \
	--slave %{_mandir}/man1/rmiregistry.1.bz2 rmiregistry.1.bz2 %{_mandir}/man1/gcj-rmiregistry.1.bz2

%preun -n libgcj
if [ $1 = 0 ]; then
  /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/fastjar.info
fi

%postun -n libgcj
/sbin/ldconfig
%{_sbindir}/alternatives --remove jar %{_bindir}/gcj-jar
%{_sbindir}/alternatives --remove rmic %{_bindir}/gcj-rmic
%{_sbindir}/alternatives --remove rmiregistry %{_bindir}/gcj-rmiregistry

%post -n libf2c -p /sbin/ldconfig

%postun -n libf2c -p /sbin/ldconfig
%endif # !bootstrap_build

%files -f %{name}.lang
%defattr(-,root,root)
%{_bindir}/cc
%{_bindir}/c89
%{_bindir}/c99
%{_bindir}/gcc
%{_bindir}/gcov
%{_bindir}/protoize
%{_bindir}/unprotoize
%ifarch sparc ppc
#%%{_bindir}/%{_target_platform}-gcc
%endif # sparc ppc
%ifarch sparc64
%{_bindir}/sparc-%{_vendor}-%{_target_os}-gcc
%endif # sparc64
%ifarch ppc64
%{_bindir}/ppc-%{_vendor}-%{_target_os}-gcc
%endif # ppc64
%{_bindir}/%{gcc_target_platform}-gcc
%{_mandir}/man1/gcc.1*
%{_mandir}/man1/gcov.1*
%{_infodir}/gcc*
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_libexecdir}/gcc
%dir %{_libexecdir}/gcc/%{gcc_target_platform}
%dir %{_libexecdir}/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stddef.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stdarg.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/varargs.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/float.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/limits.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stdbool.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/iso646.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/syslimits.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/unwind.h
%ifarch %{ix86} x86_64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/xmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/emmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/pmmintrin.h
%endif # ix86 && x86_64
%ifarch ia64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ia64intrin.h
%endif # ia64
%ifarch ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ppc-asm.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/altivec.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/spe.h
%endif # ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/README
%{_libexecdir}/gcc/%{gcc_target_platform}/%{gcc_version}/cc1
%{_libexecdir}/gcc/%{gcc_target_platform}/%{gcc_version}/collect2
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcov.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_s.so
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcov.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_s_32.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/ecrti.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/ecrtn.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/ncrti.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/ncrtn.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/lib-gnu-java-awt-peer-gtk.la
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/lib-org-w3c-dom.la
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/lib-org-xml-sax.la
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/libgcj.la
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/libstdc++.la
%endif # sparc ppc
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcov.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_s_32.so
%endif # multilib_64_archs
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/specs
%doc gcc/README* gcc/*ChangeLog*

%files -n cpp
%defattr(-,root,root)
/lib/cpp
%{_bindir}/cpp
%{_mandir}/man1/cpp.1*
%{_infodir}/cpp*
#%%dir %{_libexecdir}/gcc
#%%dir %{_libexecdir}/gcc/%{gcc_target_platform}
#%%dir %{_libexecdir}/gcc/%{gcc_target_platform}/%{gcc_version}

%files -n libgcc
%defattr(-,root,root)
/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
/%{_lib}/libgcc_s.so.1
%{_prefix}/sbin/libgcc_post_upgrade

%files c++
%defattr(-,root,root)
%{_bindir}/%{gcc_target_platform}-*++
%{_bindir}/g++
%{_bindir}/c++
#%%{_bindir}/c++filt
%{_mandir}/man1/g++.1*
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_libexecdir}/gcc
%dir %{_libexecdir}/gcc/%{gcc_target_platform}
%dir %{_libexecdir}/gcc/%{gcc_target_platform}/%{gcc_version}
%{_libexecdir}/gcc/%{gcc_target_platform}/%{gcc_version}/cc1plus
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.a
#%%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
#%%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libsupc++.a
%endif # sparc ppc
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libsupc++.a
%endif # multilib_64_archs
%ifarch sparc ppc %{multilib_64_archs}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
%endif # sparc ppc multilib_64_archs
%ifarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.a
%endif # sparc sparc64 ppc ppc64
%doc gcc/cp/ChangeLog*

%files -n libstdc++
%defattr(-,root,root)
%{_libdir}/libstdc++.so.6*

%files -n libstdc++-devel
%defattr(-,root,root)
%{_includedir}/c++
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/libstdc++.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/nof/*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/nof/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/nof/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/nof/libgcov.a
%{_libdir}/libgcc_s_nof.so.1
%{_libdir}/nof/libffi-2.00-beta.so
%{_libdir}/nof/libffi.a
%{_libdir}/nof/libffi.la
%{_libdir}/nof/libfrtbegin.a
%{_libdir}/nof/libg2c.a
%{_libdir}/nof/libg2c.la
%{_libdir}/nof/libg2c.so.0.0.0
%{_libdir}/nof/libiberty.a
%{_libdir}/nof/libobjc.a
%{_libdir}/nof/libobjc.la
%{_libdir}/nof/libobjc.so.1.0.0
%{_libdir}/nof/libstdc++.a
%{_libdir}/nof/libstdc++.la
%{_libdir}/nof/libstdc++.so.6.0.3
%{_libdir}/nof/libsupc++.a
%{_libdir}/nof/libsupc++.la
%endif # sparc ppc
%ifarch sparc64 ppc64
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64/libstdc++.a
%endif # sparc64 ppc64
%ifnarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.a
%endif # sparc sparc64 ppc ppc64
%ifnarch sparc ppc %{multilib_64_archs}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
%endif # sparc ppc multilib_64_archs
%doc libstdc++-v3/ChangeLog* libstdc++-v3/README* libstdc++-v3/docs/html/

%if %{build_d_lang}
%files d
%defattr(-,root,root)
%{_bindir}/dmd
%{_bindir}/gdc
%{_bindir}/%{gcc_target_platform}-gdc
%{_libexecdir}/gcc/%{gcc_target_platform}/%{gcc_version}/cc1d
%{_includedir}/d
%{_libdir}/libphobos.a
%{_libdir}/libphobos.spec
%endif


%if !%{bootstrap_build}
%files objc
%defattr(-,root,root)
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_libexecdir}/gcc
%dir %{_libexecdir}/gcc/%{gcc_target_platform}
%dir %{_libexecdir}/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/objc
%{_libexecdir}/gcc/%{gcc_target_platform}/%{gcc_version}/cc1obj
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libobjc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libobjc.so
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libobjc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libobjc.so
%endif # sparc ppc
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libobjc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libobjc.so
%endif # multilib_64_archs
%doc rpm.doc/objc/*
%doc libobjc/THREADS* libobjc/ChangeLog

%files -n libobjc
%defattr(-,root,root)
%{_libdir}/libobjc.so.1*

%files g77
%defattr(-,root,root)
%{_bindir}/g77
%{_bindir}/f77
%{_mandir}/man1/g77.1*
%{_infodir}/g77*
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_libexecdir}/gcc
%dir %{_libexecdir}/gcc/%{gcc_target_platform}
%dir %{_libexecdir}/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include
%{_libexecdir}/gcc/%{gcc_target_platform}/%{gcc_version}/f771
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libfrtbegin.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libg2c.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libg2c.so
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libfrtbegin.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libg2c.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libg2c.so
%endif # sparc ppc
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libfrtbegin.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libg2c.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libg2c.so
%endif # multilib_64_archs
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/g2c.h
%doc rpm.doc/g77/*

%files -n libf2c
%defattr(-,root,root)
%{_libdir}/libg2c.so.0*

%files java
%defattr(-,root,root)
%{_bindir}/gcj
%{_bindir}/gcjh
%{_bindir}/jcf-dump
%{_bindir}/jv-scan
%{_mandir}/man1/gcj.1*
%{_mandir}/man1/gcjh.1*
%{_mandir}/man1/jcf-dump.1*
%{_mandir}/man1/jv-scan.1*
%{_infodir}/gcj*
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_libexecdir}/gcc
%dir %{_libexecdir}/gcc/%{gcc_target_platform}
%dir %{_libexecdir}/gcc/%{gcc_target_platform}/%{gcc_version}
%{_libexecdir}/gcc/%{gcc_target_platform}/%{gcc_version}/jc1
%{_libexecdir}/gcc/%{gcc_target_platform}/%{gcc_version}/jvgenmain
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcj.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib-gnu-java-awt-peer-gtk.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib-org-w3c-dom.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib-org-xml-sax.so
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcj.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/lib-gnu-java-awt-peer-gtk.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/lib-org-w3c-dom.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/lib-org-xml-sax.so
%endif # sparc ppc
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcj.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/lib-gnu-java-awt-peer-gtk.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/lib-org-w3c-dom.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/lib-org-xml-sax.so
%endif # multilib_64_archs
%doc gcc/java/ChangeLog*

%files -n libgcj
%defattr(-,root,root)
%{_bindir}/jv-convert
%{_bindir}/gij
%{_bindir}/gcj-jar
%{_bindir}/grepjar
%{_bindir}/gcj-rmic
%{_bindir}/gcj-rmiregistry
%{_mandir}/man1/gcj-jar.1*
%{_mandir}/man1/grepjar.1*
%{_mandir}/man1/jv-convert.1*
%{_mandir}/man1/gij.1*
%{_mandir}/man1/gcj-rmic.1*
%{_mandir}/man1/gcj-rmiregistry.1*
%{_infodir}/fastjar*
%{_libdir}/libgcj.so.*
%{_libdir}/lib-gnu-java-awt-peer-gtk.so.*
%{_libdir}/lib-org-w3c-dom.so.*
%{_libdir}/lib-org-xml-sax.so.*
%{_datadir}/java/libgcj-%{version}.jar
#%%{_datadir}/java
%{_prefix}/lib/security
%{_prefix}/lib/logging.properties

%files -n libgcj-devel
%defattr(-,root,root)
%{_bindir}/addr2name.awk
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcj.spec
#%%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/gc*.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/j*.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/java
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/javax
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/gnu
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/gcj
#%%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/org
%{_libdir}/pkgconfig/libgcj.pc
%doc rpm.doc/boehm-gc/* rpm.doc/fastjar/* rpm.doc/libffi/*
%doc rpm.doc/libjava/*
%endif # !bootstrap_build

%ifarch sparc
%files sparc32
%defattr(-,root,root)
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{_target_platform}
%dir %{_prefix}/lib/gcc/%{_target_platform}/%{gcc_version}
%dir %{_libexecdir}/gcc
%dir %{_libexecdir}/gcc/%{_target_platform}
%dir %{_libexecdir}/gcc/%{_target_platform}/%{gcc_version}
%{_libexecdir}/gcc/%{_target_platform}/%{gcc_version}/cc1
%{_prefix}/lib/gcc/%{_target_platform}/%{gcc_version}/include

%files c++-sparc32
%defattr(-,root,root)
%dir %{_libexecdir}/gcc
%dir %{_libexecdir}/gcc/%{_target_platform}
%dir %{_libexecdir}/gcc/%{_target_platform}/%{gcc_version}
%{_libexecdir}/gcc/%{_target_platform}/%{gcc_version}/cc1plus
%endif # sparc

%ifarch ppc
%files ppc32
%defattr(-,root,root)
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{_target_platform}
%dir %{_prefix}/lib/gcc/%{_target_platform}/%{gcc_version}
%dir %{_libexecdir}/gcc
%dir %{_libexecdir}/gcc/%{_target_platform}
%dir %{_libexecdir}/gcc/%{_target_platform}/%{gcc_version}
%{_libexecdir}/gcc/%{_target_platform}/%{gcc_version}/cc1

%files c++-ppc32
%defattr(-,root,root)
%dir %{_libexecdir}/gcc
%dir %{_libexecdir}/gcc/%{_target_platform}
%dir %{_libexecdir}/gcc/%{_target_platform}/%{gcc_version}
%{_libexecdir}/gcc/%{_target_platform}/%{gcc_version}/cc1plus
%endif # ppc

%changelog
* Thu Jul 14 2005 Ryu SASAOKA <ryu@momonga-linux.org>
- (3.4.3-15m)
- rebuild against zlib-devel 1.2.2-2m, which fixes CAN-2005-2096.

* Tue Apr 26 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.4.3-14m)
- sync with Fedora (3.4.3-20)
- update DATE 20050222
- delete Patch8: gcc34-ifcvt-pr19579.patch
- delete Patch13: gcc34-c++-pr19666.patch
- delete Patch14: gcc34-pie.patch
- add gcc34-pr14236-revert.patch
- add gcc34-pr18371.patch
- add gcc34-pr19019.patch
- add gcc34-pr19823.patch
- changelog is below
- - Tue Feb 22 2005 Jakub Jelinek  <jakub@redhat.com> 3.4.3-20
- - update from gcc-3_4-branch
-   - PRs c++/14479, c++/19487, c++/19739, c++/19755, c++/19762, c++/19787,
- 	c++/20028, libstdc++/19829, libstdc++/19946, libstdc++/19955,
- 	middle-end/19697, preprocessor/19077, target/19019, target/19715
-   - rename PowerPC IBM long double helper routines _xlq* to __gcc_*,
-     but keep _xlq*@GCC_3.4 aliases around (#148841, PR target/19019)
- - change __cxa_demangle to match cxx-abi change
-   http://www.codesourcery.com/archives/cxx-abi-dev/msg01877.html
-   (Jason Merrill, #133406)
- - only obsolete < NVR gcc-gnat and libgnat if %%{build_ada} is 0
-   (#139537)
- - revert the alloca vs. VLA patch, it has too many false positives (#147758)
- - make sure libjava GC memory is executable for libffi trampolines sake
-   (#149348, PR libgcj/19823)

* Thu Apr 21 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.4.3-13m)
- change momonga_release to 2.0

* Fri Apr 15 2005 mutecat <mutecat@momonga-linux.org>
- (3.4.3-12m)
- ppc without D language support

* Thu Mar 24 2005 YAMAZAKI Makoto <zaki@zakky.org>
- (3.4.3-11m)
- 

* Thu Mar 17 2005 YAMAZAKI Makoto <zaki@zakky.org>
- (3.4.3-10m)
- added D language support

* Sat Mar 12 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (3.4.3-9m)
- disable ssp patch for ppc

* Thu Feb 24 2005 mutecat <mutecat@momonga-linux.org>
- (3.4.3-8m)
- arrange ppc avoid conflict 

* Sat Feb 19 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.4.3-7m)
- merge fc 3.4.3-19
  add Patch14: gcc34-pie.patch
  renew Patch13: gcc34-c++-pr19666.patch
  renew libgcc_post_upgrade.c

* Sun Feb 13 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.4.3-6m)
- merge fc 3.4.3-18 

* Sun Feb 13 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.4.3-5m)
- merge fc 3.4.3-16 (use fc source and patches)

* Sun Jan 16 2005 Dai OKUYAMA <dai@3hands.net>
- (3.4.3-4m)
- %{_libdir}/gcc -> %{_prefix}/lib/gcc for multilib gcc

* Sun Dec 05 2004 mutecat <mutecat@momonga-linux.org>
- (3.4.3-3m)
- arrange ppc

* Sat Nov 13 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.4.3-2m)
- add do_test into specopt

* Sat Nov 06 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.4.3-1m)
- update to 3.4.3
- arrange ssp patch

* Mon Oct  4 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (3.4.2-3m)
- move cc1 from cpp to gcc package

* Mon Sep 27 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (3.4.2-2m)
- update patches from Fedora (3.4.2-2)
- update ssp patch to 3.4.1-1

* Tue Sep  7 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (3.4.2-1m)
- bug fix release
- update patches from Fedora (3.4.1-10)

* Tue Aug 31 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (3.4.1-2m)
- change BuildPrereq: XFree86-devel -> gtk+-devel for Java AWT
- add Provides: %%{_prefix}/sbin/libgcc_post_upgrade
- sync with Fedora (3.4.1-9)
- * Sat Aug 21 2004 Jakub Jelinek  <jakub@redhat.com> 3.4.1-9
- - make no-dot-syms on ppc64 runtime selectable:
-   -m64 -mcall-linux (the default) will use no dot symbols,
-   -m32 -mcall-aixdesc will use dot symbols
- - backport C++ visibility patches, -fvisibility*, #pragma GCC visibility
- - backport s390{,x} -mkernel-backchain and stack checking changes,
-   though for this rpm version the patches are still not applied
- - add spe.h header on ppc and ppc64, altivec.h and ppc-asm.h on ppc64
- - add gcc34* and lib*34 Provides
- - use libgcj-javac-placeholder.sh for javac alternative(8),
-   run exec gcj -C "$@" at the end of it and gij "$@" at the end
-   of libgcj-java-placeholder.sh
- 
- * Tue Aug 17 2004 Jakub Jelinek  <jakub@redhat.com> 3.4.1-8
- - update from gcc-3_4-branch
-   - PRs 13956, 16684, bootstrap/16469, c++/16175, c++/16224, c++/16273,
-         c++/16489, c++/16529, c++/16618, c++/16637, c++/16698, c++/16717,
-         c++/16810, c++/16853, c++/16870, c++/16904, c++/16929, c++/16964,
-         libgfortran/15930, libstdc++/12658, libstdc++/14697,
-         libstdc++/16813, libstdc++/16959, middle-end/16790, other/16842,
-         preprocessor/16366, rtl-optimization/16490, rtl-optimization/16536,
-         rtl-optimization/16643, target/16239, target/16325
- - avoid making silly copies in convert_move (Jeff Law)
- - make sure all files in libgcj*.jar have identical timestamps
-   accross all the architectures (#128431)
- - one more gcj -C fix to make sure .class files are identical between
-   32-bit and 64-bit targets (#128431)
- - put jumptables for .gnu.linkonce.t.* sections into .gnu.linkonce.r.*
-   sections instead of .rodata (#129574, PR c++/16276)
- - rtti linkonce fix (H.J.Lu, PR c++/16276)
- - handle filenames with embedded spaces in gcj
-   (Elliot Lee, #129675, PR java/9677)
- - stop using dot symbols on ppc64 (Alan Modra)
- - overlap fd_aux field of ppc64 .opd entries with next .opd entry's fd_func
-   if a function is not going to use r11 passed to it
- - avoid building multilib libjava's - they shouldn't be needed for packaging
-   and otherwise we would need all of Gtk+ installed as both 32-bit and
-   64-bit development environment
- 
- * Thu Aug 12 2004 Thomas Fitzsimmons <fitzsim@redhat.com>
- - build GTK peers, backport libjava changes from gui-branch
- - rename gjar to fastjar

* Tue Aug 10 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (3.4.1-1m)
- update to 3.4.1 (sync with Fedora gcc-3.4.1-7)
- remove %%{_bindir}/c++filt (move to binutils)

* Fri Jan 09 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.3-12m)
- fix alternatives about libgcj

* Thu Jan  8 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (3.2.3-11m)
- change momonga_release to 1.0

* Sun Nov 23 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.3-10m)
- s/Copyright:/License:/

* Fri Oct 10 2003 OZAWA Sakuro <crouton@momonga-linux.org>
- (3.2.3-9m)
- alternatives(jar, rmic, rmiregistry and their manpages)

* Mon Oct  6 2003 Hideo TASHIRO <tashiron@jasmiso.org>
- (3.2.3-8m)
- fix typo   s/bootstarp/bootstrap/g
- it is made not to make gcj-jar when bootstrap_build

* Thu Aug  7 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2.3-7m)
- update ssp patch to 3.2.2-10

* Thu Jul 24 2003 HOSONO Hidetomo <h12o@h12o.org>
- (3.2.3-6m)
- remove gcc-specs-sspfix.diff
- add a sed one-liner instead of patching gcc-specs-sspfix.diff

* Sat Jul 19 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2.3-5m)
- rebuild against glibc-2.3.2

* Sun Jul  6 2003 Kenta MURATA <muraken2@nifty.com>
- (3.2.3-4m)
- rebuild against rpm.

* Sat Jun 28 2003 Kenta MURATA <muraken2@nifty.com>
- (3.2.3-3m)
- mv jar gcj-jar for kaffe.

* Thu May 08 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.3-2m)
- update ssp protector patch to 3.2.2-7

* Sat Apr 26 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.3-1m)
- update to 3.2.3
- fix rpm macros miss in files section at ifarch sparc (s|{_libdir}|%%{_libdir}|g)
- change "%%{__tar} zxvf" to "%%{__tar} zxf" %%{SOURCE1} (ssp patch)
- update DATE macro, unneed?

* Sun Apr 20 2003 Kenta MURATA <muraken2@nifty.com>
- (3.2.2-15m)
- cancel patch0 because can not build kernel.

* Sun Apr 20 2003 HOSONO Hidetomo <h12o@h12o.org>
- (3.2.2-14m)
- fix the URL of Source1:

* Fri Apr 18 2003 Kenta MURATA <muraken2@nifty.com>
- (3.2.2-13m)
- synchronize to RH9.

* Tue Apr 15 2003 Kenta MURATA <muraken2@nifty.com>
- (3.2.2-12m)
- syncronize to rawhide gcc (3.2.2-10).

* Sun Apr 13 2003 Kenta MURATA <muraken2@nifty.com>
- (3.2.2-11m)
- modify argument of install-info.

* Fri Apr 04 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.2-10m)
- rebuild against zlib 1.1.4-5m
- add BuildPrereq: zlib-devel >= 1.1.4-5m

* Sun Mar 23 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.2-9m)
- move Name: section top of spec file [Momonga-devel.ja:01504] 
- comment out <URL:http:\/\/www.momonga-linux.org\/> gcc/system.h
  using URL when cc1 internal compile error...
- change %%{_prefix}/%%{_lib} to %%{_libdir}

* Sun Mar 16 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2.2-8m)
- update ssp patch to 3.2.2-3 
- fix specs for ssp(gcc-specs-sspfix.diff)

* Fri Feb 28 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2.2-7m)
- update ssp patch

* Tue Feb 18 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2.2-6m)
- install hoge.info instead of hoge.info.* in %%post and %%preun
- fix error of %%post on libgcj

* Mon Feb 17 2003 Kenta MURATA <muraken2@nifty.com>
- (3.2.2-5m)
- libgcj must contain libgcjx.

* Mon Feb 17 2003 Kenta MURATA <muraken2@nifty.com>
- (3.2.2-4m)
- modify the %%install section to fix to unmatch pushd/popd pair in
  positive bootstrap_build.
- use --enable-languages option in configure.

* Mon Feb 17 2003 Kenta MURATA <muraken2@nifty.com>
- (3.2.2-3m)
- enable java-awt support.
- disable compile g77, objc and java support when bootstrap_build is
  positive.

* Tue Feb 11 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2.2-2m)
- fix ssp

* Sat Feb  8 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (3.2.2-1m)
  update to 3.2.2

* Mon Jan 20 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2-9m)
- fix %%post and %%preun of libgcj for compressed info file

* Wed Nov 27 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2-8m)
- sync with redhat(gcc-3.2-14)
- add changelog of redhat gcc-3.2-14(rawhide) below
-
-* Sun Nov 17 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-14
-- really fix check-abi problem on ia64/alpha
-
-* Sat Nov 16 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-13
-- update from gcc-3_2-rhl8-branch
-  - fix flow (Graham Scott, Jan Hubicka)
-  - fix check-abi problem on ia64/alpha (Benjamin Kosnik)
-  - fix objc on x86_64 (Jan Hubicka, Nicola Pero)
-  - fix x86_64 profiling (Jan Hubicka)
-  - better s390* .eh_frame encoding (Ulrich Weigand)
-- build ada on x86_64
-- add fastjar info and jar and grepjar manual pages
-
-* Tue Nov 12 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-12
-- update from gcc-3_2-rhl8-branch
-  - PRs c/8467, preprocessor/4890, 8502, c/5351, optimization/7591,
-    bootstrap/8146, c/8252, optimization/7520, c/8451, c++/8391,
-    target/7856, target/7133, target/6890, middle-end/6994, opt/7944,
-    c/761, c++/7788, c++/2521, c++/8160, c++/8149, c++/8287,
-    middle-end/6994, c++/7266, c++/7228, c++/8067, c++/7679,
-    c++/6579, java/7830, libstdc++/8362, libstdc++/8258, libstdc++/7219,
-    libstdc++/8466, libstdc++/8172, libstdc++/8197, libstdc++/8318,
-    libstdc++/8348, libstdc++/7961, other/3337, bootstrap/6763,
-    bootstrap/8122, libstdc++/8347
-  - &&lab1 - &&lab2 doesn't need to be in rw section
-  - x86_64 %rip fixes
-  - fix jar c without f (#77062)
-  - backport all fastjar changes from mainline
-
-* Wed Oct 23 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-11
-- update from gcc-3_2-rhl8-branch
-  - PRs target/7693, opt/7630, c++/6419, target/7396, c++/8218,
-    c++/7676, c++/7584, c++/7478, c++/8134, c++/7524, c++/7176,
-    c++/5661, c++/6803, c++/7721, c++/7803, c++/7754, c++/7188,
-    libstdc++/8071, libstdc++/8127, c++/6745, libstdc++/8096,
-    libstdc++/7811
-- fix x86-64 ICE with stdarg in -fpic (#76491)
-- fix IA-32 miscompilation of DImode code (Jim Wilson, PR target/6981)
-
-* Wed Oct 16 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-10
-- update from gcc-3_2-rhl8-branch
-  - PRs target/7370, target/8232, opt/7409, preprocessor/7862,
-    preprocessor/8190, optimization/6631, target/5610, optimization/7951,
-    target/7723
-- allow building even if de_DE locale is not installed (#74503, #75889)
-- s390x multilib
-- x86-64 TLS fixes
-- 15 Java fixes (Anthony Green, Andrew Haley, Tom Tromey,
-  PRs java/6005, java/7611, java/8003, java/7950, java/5794, libgcj/7073)
-- %%define _unpackaged_files_terminate_build 0
-- fix make check-abi
-
-* Fri Oct 11 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-9
-- update from gcc-3_2-rhl8-branch
-  - __attribute__((tls_model("")))
-  - PRs c/7353, opt/7124, opt/7912, opt/7390, doc/7484,
-        c/7411, target/8087, optimization/6713
-- x86-64 TLS
-
-* Tue Oct  8 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-8
-- switch to gcc-3_2-rhl8-branch snapshots
-  - thus most of the patches went away as they are in CVS
-- merge from gcc-3_2-branch between 20020903 and 20021007
-  - PRs target/7434, optimization/6627, preprocessor/8120,
-       middle-end/7151, preprocessor/8055, optimization/7335,
-       c/7160, target/7842, opt/7515, optimization/7130,
-       optimization/6984, c/7150, target/7380, other/7114,
-       target/5967, optimization/7120, target/7374, opt/7814,
-       c/7102
-- backported libffi and libjava bits for x86-64 and s390*
-- added sparc* support
-- multilib setup for sparc* and x86-64
-- some IA-32 TLS fixes (Richard Henderson)

* Thu Nov 27 2002 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2-7m)
- update protector patch protector-3.2-3 to protector-3.2-5
- add BuildPreReq: binutils >= 2.13.90.0.10-2m

* Sat Nov  9 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2-6m)
- add Obsoletes: gcc-chill

* Sun Nov  3 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2-5m)
- add bootstrap_build macro(to remove -fstack-protector from %%optflags)

* Thu Oct 24 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2-4m)
- enable ssp by default

* Wed Oct  9 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2-3m)
- %%{?include_specopt}
- add ssp patch, See <http://www.trl.ibm.com/projects/security/ssp/>
  disabled by default

* Sun Oct  6 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2-2m)
- delete ada

* Tue Oct  1 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2-1m)
- update to 3.2
  sync with gcc-3.2 of redhat 8.0(gcc-3.2-7.src.rpm)

* Thu Aug  1 2002 Tsutomu Yasuda <tom@tom.homelinux.org>
- (3.1.1-1m)
  update to 3.1.1

* Tue Jul 17 2002 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.96-9m)
- s/Kondara MNU 2.1 Linux/Momonga Linux/
- change Source0 URI

* Wed May 29 2002 Tsutomu Yasuda <tom@kondara.org>
- (3.1-8k)
  applied patch
  see http://gcc.gnu.org/cgi-bin/gnatsweb.pl?cmd=view%20audit-trail&database=gcc&pr=6703

* Sat May 25 2002 Toru Hoshina <t@kondara.org>
- (3.1-6k)
- remove disgusting make check.
- apply athlon optimize patch,
  See http://gcc.gnu.org/ml/gcc/2002-05/msg01743.html

* Fri May 24 2002 Toru Hoshina <t@kondara.org>
- (3.1-4k)
- revised spec.

* Thu May 23 2002 Tsutomu Yasuda <tom@kondara.org>
- (3.1-2k)
  merge from rawhide
  3.1 first release
